#include<bits/stdc++.h>
using namespace std;
int x[1000006];
int y[1000006];

int main(){
	ios::sync_with_stdio(0); cin.tie(0);
	int m; cin >> m;
	
	for(int i = 1; i <= m; i++){
		cin >> x[i] >> y[i];
	}
	
	
	
	for(int i = 1; i <= m; i++){
		int mx = -1;
		
		for(int j = 1; j <= i; j++){
			for(int k = 1; k <= i; k++){
				//izabrana udarena tacka
				int s = 0;
				for(int l = 1, r = 1; l <= i; l++, r++){
					s += abs(x[l] - x[j]) * abs(y[k] - y[r]);
				}
				mx = max(mx, s);
			}
		}
		cout << mx << "\n";
	}
	
	return 0;
}